<template>
  <div class="scrollable">
    <div ref="RefContainer" class="container" @scroll.passive="scrolling">
      <slot></slot>
    </div>
    <span
      v-show="this.$slots.default !== undefined && !isScrolledLeft"
      class="icon-arrow-left iz_arrow"
      @click="scrollLeft"
    ></span>
    <span
      v-show="this.$slots.default !== undefined && !isScrolledRight"
      class="icon-arrow-right iz_arrow"
      @click="scrollRight"
    ></span>
  </div>
</template>

<script>
export default {
  name: 'Scrollable',
  data() {
    return {
      isScrolledLeft: true,
      isScrolledRight: false
    }
  },
  mounted: function () {
    // Hide right arrow if no scrolling required
    this.$nextTick(function () {
      // Need to wait $nextTick for html to be loaded
      if (this.$slots.default !== undefined) this.scrolling()
    })
  },
  methods: {
    scrolling: function () {
      this.isScrolledLeft = this.$refs.RefContainer.scrollLeft === 0
      this.isScrolledRight =
        this.$refs.RefContainer.offsetWidth +
          this.$refs.RefContainer.scrollLeft ==
        this.$refs.RefContainer.scrollWidth
    },
    scrollRight: function () {
      const w = this.$refs.RefContainer.getBoundingClientRect().width
      this.$refs.RefContainer.scrollTo({
        left: this.$refs.RefContainer.scrollLeft + w,
        behavior: 'smooth'
      })
    },
    scrollLeft: function () {
      const w = this.$refs.RefContainer.getBoundingClientRect().width
      this.$refs.RefContainer.scrollTo({
        left: this.$refs.RefContainer.scrollLeft - w,
        behavior: 'smooth'
      })
    }
  }
}
</script>

<style scoped lang="scss">
.scrollable {
  width: 100%;
  position: relative;
  .container {
    overflow-x: scroll;
    white-space: nowrap;
    width: 100%;
    div {
      float: inherit;
      display: inline-block;
      margin: 0px 40px 0px 0px;
      &:last-child {
        margin: 0px 0px 0px 0px;
      }
    }
    &::-webkit-scrollbar {
      display: none;
    }
  }
}

.iz_arrow {
  background-color: #ff641e;
  color: white;
  border-radius: 50%;
  width: 45px;
  height: 45px;
  display: block;
  text-align: center;
  line-height: 45px;
  position: absolute;
  right: -20px;
  top: calc(50% - 22px);
  cursor: pointer;
  font-size: 18px;
}
.icon-arrow-right {
  right: -20px;
}
.icon-arrow-left {
  left: -20px;
}
</style>
